# Swagger\Client\PostcodesApi

All URIs are relative to *https://appwx.weathersourceapis.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**postcodesPostcodecountryCodeGet**](PostcodesApi.md#postcodespostcodecountrycodeget) | **GET** /postcodes/{postcode},{countryCode} | App Weather response for a postcode.

# **postcodesPostcodecountryCodeGet**
> \Swagger\Client\Model\AppwxPostcodeObj postcodesPostcodecountryCodeGet($postcode, $country_code, $services, $fields, $unit_scale, $language)

App Weather response for a postcode.

Returns select nowcast and forecast (7-day - daily and hourly) data for a postcode.  The weather icon classes returned by this API correspond to classes used by the open source licensed [Weather Icons](https://developer.weathersourceapis.com/apis/appwx-weather-icons/) font set.  **IMPORTANT:** To authenticate to the Weather Source App Weather API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-API-KEY', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-KEY', 'Bearer');

$apiInstance = new Swagger\Client\Api\PostcodesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$postcode = "postcode_example"; // string | A postcode string.
$country_code = "country_code_example"; // string | An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/).
$services = array("services_example"); // string[] | A comma separated list of service names to return.  **Limiting the query to needed services will improve the query response time.**
$fields = array("fields_example"); // string[] | A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**
$unit_scale = "IMPERIAL"; // string | The unit scale for returned values.<br>
$language = "ENGLISH"; // string | The language for translatable returned values.<br>

try {
    $result = $apiInstance->postcodesPostcodecountryCodeGet($postcode, $country_code, $services, $fields, $unit_scale, $language);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PostcodesApi->postcodesPostcodecountryCodeGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **postcode** | **string**| A postcode string. |
 **country_code** | **string**| An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). |
 **services** | [**string[]**](../Model/string.md)| A comma separated list of service names to return.  **Limiting the query to needed services will improve the query response time.** |
 **fields** | [**string[]**](../Model/string.md)| A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.** |
 **unit_scale** | **string**| The unit scale for returned values.&lt;br&gt; | [optional] [default to IMPERIAL]
 **language** | **string**| The language for translatable returned values.&lt;br&gt; | [optional] [default to ENGLISH]

### Return type

[**\Swagger\Client\Model\AppwxPostcodeObj**](../Model/AppwxPostcodeObj.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

