<?php
/**
 * PostcodesApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * App Weather - A Weather Source API
 *
 * App/Webpage optimized weather data for latitude/longitude points, ZIP/Postal Codes, and OnPoint™ points. The Weather Source App Weather API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate use. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  This API returns current conditions (Nowcast) and a 7-day of daily and hourly forecast. The nowcast and forecasts include limited astronomical data.  The weather icon classes returned by this API correspond to classes used by the open source licensed [Weather Icons](https://developer.weathersourceapis.com/apis/appwx-weather-icons/) font set.      **IMPORTANT:** To authenticate to the Weather Source App Weather API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.23
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * PostcodesApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PostcodesApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation postcodesPostcodecountryCodeGet
     *
     * App Weather response for a postcode.
     *
     * @param  string $postcode A postcode string. (required)
     * @param  string $country_code An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). (required)
     * @param  string[] $services A comma separated list of service names to return.  **Limiting the query to needed services will improve the query response time.** (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.** (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     * @param  string $language The language for translatable returned values.&lt;br&gt; (optional, default to ENGLISH)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\AppwxPostcodeObj
     */
    public function postcodesPostcodecountryCodeGet($postcode, $country_code, $services, $fields, $unit_scale = 'IMPERIAL', $language = 'ENGLISH')
    {
        list($response) = $this->postcodesPostcodecountryCodeGetWithHttpInfo($postcode, $country_code, $services, $fields, $unit_scale, $language);
        return $response;
    }

    /**
     * Operation postcodesPostcodecountryCodeGetWithHttpInfo
     *
     * App Weather response for a postcode.
     *
     * @param  string $postcode A postcode string. (required)
     * @param  string $country_code An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). (required)
     * @param  string[] $services A comma separated list of service names to return.  **Limiting the query to needed services will improve the query response time.** (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.** (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     * @param  string $language The language for translatable returned values.&lt;br&gt; (optional, default to ENGLISH)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\AppwxPostcodeObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function postcodesPostcodecountryCodeGetWithHttpInfo($postcode, $country_code, $services, $fields, $unit_scale = 'IMPERIAL', $language = 'ENGLISH')
    {
        $returnType = '\Swagger\Client\Model\AppwxPostcodeObj';
        $request = $this->postcodesPostcodecountryCodeGetRequest($postcode, $country_code, $services, $fields, $unit_scale, $language);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\AppwxPostcodeObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postcodesPostcodecountryCodeGetAsync
     *
     * App Weather response for a postcode.
     *
     * @param  string $postcode A postcode string. (required)
     * @param  string $country_code An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). (required)
     * @param  string[] $services A comma separated list of service names to return.  **Limiting the query to needed services will improve the query response time.** (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.** (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     * @param  string $language The language for translatable returned values.&lt;br&gt; (optional, default to ENGLISH)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postcodesPostcodecountryCodeGetAsync($postcode, $country_code, $services, $fields, $unit_scale = 'IMPERIAL', $language = 'ENGLISH')
    {
        return $this->postcodesPostcodecountryCodeGetAsyncWithHttpInfo($postcode, $country_code, $services, $fields, $unit_scale, $language)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postcodesPostcodecountryCodeGetAsyncWithHttpInfo
     *
     * App Weather response for a postcode.
     *
     * @param  string $postcode A postcode string. (required)
     * @param  string $country_code An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). (required)
     * @param  string[] $services A comma separated list of service names to return.  **Limiting the query to needed services will improve the query response time.** (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.** (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     * @param  string $language The language for translatable returned values.&lt;br&gt; (optional, default to ENGLISH)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postcodesPostcodecountryCodeGetAsyncWithHttpInfo($postcode, $country_code, $services, $fields, $unit_scale = 'IMPERIAL', $language = 'ENGLISH')
    {
        $returnType = '\Swagger\Client\Model\AppwxPostcodeObj';
        $request = $this->postcodesPostcodecountryCodeGetRequest($postcode, $country_code, $services, $fields, $unit_scale, $language);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postcodesPostcodecountryCodeGet'
     *
     * @param  string $postcode A postcode string. (required)
     * @param  string $country_code An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). (required)
     * @param  string[] $services A comma separated list of service names to return.  **Limiting the query to needed services will improve the query response time.** (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.** (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     * @param  string $language The language for translatable returned values.&lt;br&gt; (optional, default to ENGLISH)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postcodesPostcodecountryCodeGetRequest($postcode, $country_code, $services, $fields, $unit_scale = 'IMPERIAL', $language = 'ENGLISH')
    {
        // verify the required parameter 'postcode' is set
        if ($postcode === null || (is_array($postcode) && count($postcode) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $postcode when calling postcodesPostcodecountryCodeGet'
            );
        }
        // verify the required parameter 'country_code' is set
        if ($country_code === null || (is_array($country_code) && count($country_code) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country_code when calling postcodesPostcodecountryCodeGet'
            );
        }
        // verify the required parameter 'services' is set
        if ($services === null || (is_array($services) && count($services) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $services when calling postcodesPostcodecountryCodeGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling postcodesPostcodecountryCodeGet'
            );
        }

        $resourcePath = '/postcodes/{postcode},{countryCode}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($services)) {
            $services = ObjectSerializer::serializeCollection($services, 'csv', true);
        }
        if ($services !== null) {
            $queryParams['services'] = ObjectSerializer::toQueryValue($services, null);
        }
        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }
        // query params
        if ($language !== null) {
            $queryParams['language'] = ObjectSerializer::toQueryValue($language, null);
        }

        // path params
        if ($postcode !== null) {
            $resourcePath = str_replace(
                '{' . 'postcode' . '}',
                ObjectSerializer::toPathValue($postcode),
                $resourcePath
            );
        }
        // path params
        if ($country_code !== null) {
            $resourcePath = str_replace(
                '{' . 'countryCode' . '}',
                ObjectSerializer::toPathValue($country_code),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
