<?php
/**
 * AppwxOnpointObj
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * App Weather - A Weather Source API
 *
 * App/Webpage optimized weather data for latitude/longitude points, ZIP/Postal Codes, and OnPoint™ points. The Weather Source App Weather API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate use. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  This API returns current conditions (Nowcast) and a 7-day of daily and hourly forecast. The nowcast and forecasts include limited astronomical data.  The weather icon classes returned by this API correspond to classes used by the open source licensed [Weather Icons](https://developer.weathersourceapis.com/apis/appwx-weather-icons/) font set.      **IMPORTANT:** To authenticate to the Weather Source App Weather API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.23
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * AppwxOnpointObj Class Doc Comment
 *
 * @category Class
 * @description OnPoint™ point App Weather object
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class AppwxOnpointObj implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'appwxOnpointObj';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'location' => '\Swagger\Client\Model\OnpointObj',
'features' => '\Swagger\Client\Model\FeaturesObj',
'nowcast' => '\Swagger\Client\Model\NowcastObj',
'forecast_day' => '\Swagger\Client\Model\ForecastDayArr',
'forecast_hour' => '\Swagger\Client\Model\ForecastHourArr'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'location' => null,
'features' => null,
'nowcast' => null,
'forecast_day' => null,
'forecast_hour' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'location' => 'location',
'features' => 'features',
'nowcast' => 'nowcast',
'forecast_day' => 'forecastDay',
'forecast_hour' => 'forecastHour'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'location' => 'setLocation',
'features' => 'setFeatures',
'nowcast' => 'setNowcast',
'forecast_day' => 'setForecastDay',
'forecast_hour' => 'setForecastHour'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'location' => 'getLocation',
'features' => 'getFeatures',
'nowcast' => 'getNowcast',
'forecast_day' => 'getForecastDay',
'forecast_hour' => 'getForecastHour'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['location'] = isset($data['location']) ? $data['location'] : null;
        $this->container['features'] = isset($data['features']) ? $data['features'] : null;
        $this->container['nowcast'] = isset($data['nowcast']) ? $data['nowcast'] : null;
        $this->container['forecast_day'] = isset($data['forecast_day']) ? $data['forecast_day'] : null;
        $this->container['forecast_hour'] = isset($data['forecast_hour']) ? $data['forecast_hour'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['location'] === null) {
            $invalidProperties[] = "'location' can't be null";
        }
        if ($this->container['features'] === null) {
            $invalidProperties[] = "'features' can't be null";
        }
        if ($this->container['nowcast'] === null) {
            $invalidProperties[] = "'nowcast' can't be null";
        }
        if ($this->container['forecast_day'] === null) {
            $invalidProperties[] = "'forecast_day' can't be null";
        }
        if ($this->container['forecast_hour'] === null) {
            $invalidProperties[] = "'forecast_hour' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets location
     *
     * @return \Swagger\Client\Model\OnpointObj
     */
    public function getLocation()
    {
        return $this->container['location'];
    }

    /**
     * Sets location
     *
     * @param \Swagger\Client\Model\OnpointObj $location location
     *
     * @return $this
     */
    public function setLocation($location)
    {
        $this->container['location'] = $location;

        return $this;
    }

    /**
     * Gets features
     *
     * @return \Swagger\Client\Model\FeaturesObj
     */
    public function getFeatures()
    {
        return $this->container['features'];
    }

    /**
     * Sets features
     *
     * @param \Swagger\Client\Model\FeaturesObj $features features
     *
     * @return $this
     */
    public function setFeatures($features)
    {
        $this->container['features'] = $features;

        return $this;
    }

    /**
     * Gets nowcast
     *
     * @return \Swagger\Client\Model\NowcastObj
     */
    public function getNowcast()
    {
        return $this->container['nowcast'];
    }

    /**
     * Sets nowcast
     *
     * @param \Swagger\Client\Model\NowcastObj $nowcast nowcast
     *
     * @return $this
     */
    public function setNowcast($nowcast)
    {
        $this->container['nowcast'] = $nowcast;

        return $this;
    }

    /**
     * Gets forecast_day
     *
     * @return \Swagger\Client\Model\ForecastDayArr
     */
    public function getForecastDay()
    {
        return $this->container['forecast_day'];
    }

    /**
     * Sets forecast_day
     *
     * @param \Swagger\Client\Model\ForecastDayArr $forecast_day forecast_day
     *
     * @return $this
     */
    public function setForecastDay($forecast_day)
    {
        $this->container['forecast_day'] = $forecast_day;

        return $this;
    }

    /**
     * Gets forecast_hour
     *
     * @return \Swagger\Client\Model\ForecastHourArr
     */
    public function getForecastHour()
    {
        return $this->container['forecast_hour'];
    }

    /**
     * Sets forecast_hour
     *
     * @param \Swagger\Client\Model\ForecastHourArr $forecast_hour forecast_hour
     *
     * @return $this
     */
    public function setForecastHour($forecast_hour)
    {
        $this->container['forecast_hour'] = $forecast_hour;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
