<?php
/**
 * ForecastDayObj
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * App Weather - A Weather Source API
 *
 * App/Webpage optimized weather data for latitude/longitude points, ZIP/Postal Codes, and OnPoint™ points. The Weather Source App Weather API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate use. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  This API returns current conditions (Nowcast) and a 7-day of daily and hourly forecast. The nowcast and forecasts include limited astronomical data.  The weather icon classes returned by this API correspond to classes used by the open source licensed [Weather Icons](https://developer.weathersourceapis.com/apis/appwx-weather-icons/) font set.      **IMPORTANT:** To authenticate to the Weather Source App Weather API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.23
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * ForecastDayObj Class Doc Comment
 *
 * @category Class
 * @description A daily weather forecast object.
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ForecastDayObj implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'forecastDayObj';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'date' => '\Swagger\Client\Model\\DateTime',
'cld_cvr_max' => '\Swagger\Client\Model\CldCvrMax',
'cld_cvr_min' => '\Swagger\Client\Model\CldCvrMin',
'feels_like_max' => '\Swagger\Client\Model\FeelsLikeMax',
'feels_like_min' => '\Swagger\Client\Model\FeelsLikeMin',
'icon' => '\Swagger\Client\Model\Icon',
'moon_phase' => '\Swagger\Client\Model\MoonPhase',
'precip' => '\Swagger\Client\Model\Precip',
'precip_prob' => '\Swagger\Client\Model\PrecipProb',
'rel_hum_max' => '\Swagger\Client\Model\RelHumMax',
'rel_hum_min' => '\Swagger\Client\Model\RelHumMin',
'snowfall' => '\Swagger\Client\Model\Snowfall',
'snowfall_prob' => '\Swagger\Client\Model\SnowfallProb',
'summary' => '\Swagger\Client\Model\Summary',
'summary_long' => '\Swagger\Client\Model\SummaryLong',
'sunrise' => '\Swagger\Client\Model\Sunrise',
'sunset' => '\Swagger\Client\Model\Sunset',
'temp_max' => '\Swagger\Client\Model\TempMax',
'temp_min' => '\Swagger\Client\Model\TempMin',
'wind_dir_avg' => '\Swagger\Client\Model\WindDirAvg',
'wind_spd_min' => '\Swagger\Client\Model\WindSpdMin',
'wind_spd_max' => '\Swagger\Client\Model\WindSpdMax'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'date' => null,
'cld_cvr_max' => null,
'cld_cvr_min' => null,
'feels_like_max' => null,
'feels_like_min' => null,
'icon' => null,
'moon_phase' => null,
'precip' => null,
'precip_prob' => null,
'rel_hum_max' => null,
'rel_hum_min' => null,
'snowfall' => null,
'snowfall_prob' => null,
'summary' => null,
'summary_long' => null,
'sunrise' => null,
'sunset' => null,
'temp_max' => null,
'temp_min' => null,
'wind_dir_avg' => null,
'wind_spd_min' => null,
'wind_spd_max' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'date' => 'date',
'cld_cvr_max' => 'cldCvrMax',
'cld_cvr_min' => 'cldCvrMin',
'feels_like_max' => 'feelsLikeMax',
'feels_like_min' => 'feelsLikeMin',
'icon' => 'icon',
'moon_phase' => 'moonPhase',
'precip' => 'precip',
'precip_prob' => 'precipProb',
'rel_hum_max' => 'relHumMax',
'rel_hum_min' => 'relHumMin',
'snowfall' => 'snowfall',
'snowfall_prob' => 'snowfallProb',
'summary' => 'summary',
'summary_long' => 'summaryLong',
'sunrise' => 'sunrise',
'sunset' => 'sunset',
'temp_max' => 'tempMax',
'temp_min' => 'tempMin',
'wind_dir_avg' => 'windDirAvg',
'wind_spd_min' => 'windSpdMin',
'wind_spd_max' => 'windSpdMax'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'date' => 'setDate',
'cld_cvr_max' => 'setCldCvrMax',
'cld_cvr_min' => 'setCldCvrMin',
'feels_like_max' => 'setFeelsLikeMax',
'feels_like_min' => 'setFeelsLikeMin',
'icon' => 'setIcon',
'moon_phase' => 'setMoonPhase',
'precip' => 'setPrecip',
'precip_prob' => 'setPrecipProb',
'rel_hum_max' => 'setRelHumMax',
'rel_hum_min' => 'setRelHumMin',
'snowfall' => 'setSnowfall',
'snowfall_prob' => 'setSnowfallProb',
'summary' => 'setSummary',
'summary_long' => 'setSummaryLong',
'sunrise' => 'setSunrise',
'sunset' => 'setSunset',
'temp_max' => 'setTempMax',
'temp_min' => 'setTempMin',
'wind_dir_avg' => 'setWindDirAvg',
'wind_spd_min' => 'setWindSpdMin',
'wind_spd_max' => 'setWindSpdMax'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'date' => 'getDate',
'cld_cvr_max' => 'getCldCvrMax',
'cld_cvr_min' => 'getCldCvrMin',
'feels_like_max' => 'getFeelsLikeMax',
'feels_like_min' => 'getFeelsLikeMin',
'icon' => 'getIcon',
'moon_phase' => 'getMoonPhase',
'precip' => 'getPrecip',
'precip_prob' => 'getPrecipProb',
'rel_hum_max' => 'getRelHumMax',
'rel_hum_min' => 'getRelHumMin',
'snowfall' => 'getSnowfall',
'snowfall_prob' => 'getSnowfallProb',
'summary' => 'getSummary',
'summary_long' => 'getSummaryLong',
'sunrise' => 'getSunrise',
'sunset' => 'getSunset',
'temp_max' => 'getTempMax',
'temp_min' => 'getTempMin',
'wind_dir_avg' => 'getWindDirAvg',
'wind_spd_min' => 'getWindSpdMin',
'wind_spd_max' => 'getWindSpdMax'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['date'] = isset($data['date']) ? $data['date'] : null;
        $this->container['cld_cvr_max'] = isset($data['cld_cvr_max']) ? $data['cld_cvr_max'] : null;
        $this->container['cld_cvr_min'] = isset($data['cld_cvr_min']) ? $data['cld_cvr_min'] : null;
        $this->container['feels_like_max'] = isset($data['feels_like_max']) ? $data['feels_like_max'] : null;
        $this->container['feels_like_min'] = isset($data['feels_like_min']) ? $data['feels_like_min'] : null;
        $this->container['icon'] = isset($data['icon']) ? $data['icon'] : null;
        $this->container['moon_phase'] = isset($data['moon_phase']) ? $data['moon_phase'] : null;
        $this->container['precip'] = isset($data['precip']) ? $data['precip'] : null;
        $this->container['precip_prob'] = isset($data['precip_prob']) ? $data['precip_prob'] : null;
        $this->container['rel_hum_max'] = isset($data['rel_hum_max']) ? $data['rel_hum_max'] : null;
        $this->container['rel_hum_min'] = isset($data['rel_hum_min']) ? $data['rel_hum_min'] : null;
        $this->container['snowfall'] = isset($data['snowfall']) ? $data['snowfall'] : null;
        $this->container['snowfall_prob'] = isset($data['snowfall_prob']) ? $data['snowfall_prob'] : null;
        $this->container['summary'] = isset($data['summary']) ? $data['summary'] : null;
        $this->container['summary_long'] = isset($data['summary_long']) ? $data['summary_long'] : null;
        $this->container['sunrise'] = isset($data['sunrise']) ? $data['sunrise'] : null;
        $this->container['sunset'] = isset($data['sunset']) ? $data['sunset'] : null;
        $this->container['temp_max'] = isset($data['temp_max']) ? $data['temp_max'] : null;
        $this->container['temp_min'] = isset($data['temp_min']) ? $data['temp_min'] : null;
        $this->container['wind_dir_avg'] = isset($data['wind_dir_avg']) ? $data['wind_dir_avg'] : null;
        $this->container['wind_spd_min'] = isset($data['wind_spd_min']) ? $data['wind_spd_min'] : null;
        $this->container['wind_spd_max'] = isset($data['wind_spd_max']) ? $data['wind_spd_max'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['date'] === null) {
            $invalidProperties[] = "'date' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets date
     *
     * @return \Swagger\Client\Model\\DateTime
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param \Swagger\Client\Model\\DateTime $date date
     *
     * @return $this
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets cld_cvr_max
     *
     * @return \Swagger\Client\Model\CldCvrMax
     */
    public function getCldCvrMax()
    {
        return $this->container['cld_cvr_max'];
    }

    /**
     * Sets cld_cvr_max
     *
     * @param \Swagger\Client\Model\CldCvrMax $cld_cvr_max cld_cvr_max
     *
     * @return $this
     */
    public function setCldCvrMax($cld_cvr_max)
    {
        $this->container['cld_cvr_max'] = $cld_cvr_max;

        return $this;
    }

    /**
     * Gets cld_cvr_min
     *
     * @return \Swagger\Client\Model\CldCvrMin
     */
    public function getCldCvrMin()
    {
        return $this->container['cld_cvr_min'];
    }

    /**
     * Sets cld_cvr_min
     *
     * @param \Swagger\Client\Model\CldCvrMin $cld_cvr_min cld_cvr_min
     *
     * @return $this
     */
    public function setCldCvrMin($cld_cvr_min)
    {
        $this->container['cld_cvr_min'] = $cld_cvr_min;

        return $this;
    }

    /**
     * Gets feels_like_max
     *
     * @return \Swagger\Client\Model\FeelsLikeMax
     */
    public function getFeelsLikeMax()
    {
        return $this->container['feels_like_max'];
    }

    /**
     * Sets feels_like_max
     *
     * @param \Swagger\Client\Model\FeelsLikeMax $feels_like_max feels_like_max
     *
     * @return $this
     */
    public function setFeelsLikeMax($feels_like_max)
    {
        $this->container['feels_like_max'] = $feels_like_max;

        return $this;
    }

    /**
     * Gets feels_like_min
     *
     * @return \Swagger\Client\Model\FeelsLikeMin
     */
    public function getFeelsLikeMin()
    {
        return $this->container['feels_like_min'];
    }

    /**
     * Sets feels_like_min
     *
     * @param \Swagger\Client\Model\FeelsLikeMin $feels_like_min feels_like_min
     *
     * @return $this
     */
    public function setFeelsLikeMin($feels_like_min)
    {
        $this->container['feels_like_min'] = $feels_like_min;

        return $this;
    }

    /**
     * Gets icon
     *
     * @return \Swagger\Client\Model\Icon
     */
    public function getIcon()
    {
        return $this->container['icon'];
    }

    /**
     * Sets icon
     *
     * @param \Swagger\Client\Model\Icon $icon icon
     *
     * @return $this
     */
    public function setIcon($icon)
    {
        $this->container['icon'] = $icon;

        return $this;
    }

    /**
     * Gets moon_phase
     *
     * @return \Swagger\Client\Model\MoonPhase
     */
    public function getMoonPhase()
    {
        return $this->container['moon_phase'];
    }

    /**
     * Sets moon_phase
     *
     * @param \Swagger\Client\Model\MoonPhase $moon_phase moon_phase
     *
     * @return $this
     */
    public function setMoonPhase($moon_phase)
    {
        $this->container['moon_phase'] = $moon_phase;

        return $this;
    }

    /**
     * Gets precip
     *
     * @return \Swagger\Client\Model\Precip
     */
    public function getPrecip()
    {
        return $this->container['precip'];
    }

    /**
     * Sets precip
     *
     * @param \Swagger\Client\Model\Precip $precip precip
     *
     * @return $this
     */
    public function setPrecip($precip)
    {
        $this->container['precip'] = $precip;

        return $this;
    }

    /**
     * Gets precip_prob
     *
     * @return \Swagger\Client\Model\PrecipProb
     */
    public function getPrecipProb()
    {
        return $this->container['precip_prob'];
    }

    /**
     * Sets precip_prob
     *
     * @param \Swagger\Client\Model\PrecipProb $precip_prob precip_prob
     *
     * @return $this
     */
    public function setPrecipProb($precip_prob)
    {
        $this->container['precip_prob'] = $precip_prob;

        return $this;
    }

    /**
     * Gets rel_hum_max
     *
     * @return \Swagger\Client\Model\RelHumMax
     */
    public function getRelHumMax()
    {
        return $this->container['rel_hum_max'];
    }

    /**
     * Sets rel_hum_max
     *
     * @param \Swagger\Client\Model\RelHumMax $rel_hum_max rel_hum_max
     *
     * @return $this
     */
    public function setRelHumMax($rel_hum_max)
    {
        $this->container['rel_hum_max'] = $rel_hum_max;

        return $this;
    }

    /**
     * Gets rel_hum_min
     *
     * @return \Swagger\Client\Model\RelHumMin
     */
    public function getRelHumMin()
    {
        return $this->container['rel_hum_min'];
    }

    /**
     * Sets rel_hum_min
     *
     * @param \Swagger\Client\Model\RelHumMin $rel_hum_min rel_hum_min
     *
     * @return $this
     */
    public function setRelHumMin($rel_hum_min)
    {
        $this->container['rel_hum_min'] = $rel_hum_min;

        return $this;
    }

    /**
     * Gets snowfall
     *
     * @return \Swagger\Client\Model\Snowfall
     */
    public function getSnowfall()
    {
        return $this->container['snowfall'];
    }

    /**
     * Sets snowfall
     *
     * @param \Swagger\Client\Model\Snowfall $snowfall snowfall
     *
     * @return $this
     */
    public function setSnowfall($snowfall)
    {
        $this->container['snowfall'] = $snowfall;

        return $this;
    }

    /**
     * Gets snowfall_prob
     *
     * @return \Swagger\Client\Model\SnowfallProb
     */
    public function getSnowfallProb()
    {
        return $this->container['snowfall_prob'];
    }

    /**
     * Sets snowfall_prob
     *
     * @param \Swagger\Client\Model\SnowfallProb $snowfall_prob snowfall_prob
     *
     * @return $this
     */
    public function setSnowfallProb($snowfall_prob)
    {
        $this->container['snowfall_prob'] = $snowfall_prob;

        return $this;
    }

    /**
     * Gets summary
     *
     * @return \Swagger\Client\Model\Summary
     */
    public function getSummary()
    {
        return $this->container['summary'];
    }

    /**
     * Sets summary
     *
     * @param \Swagger\Client\Model\Summary $summary summary
     *
     * @return $this
     */
    public function setSummary($summary)
    {
        $this->container['summary'] = $summary;

        return $this;
    }

    /**
     * Gets summary_long
     *
     * @return \Swagger\Client\Model\SummaryLong
     */
    public function getSummaryLong()
    {
        return $this->container['summary_long'];
    }

    /**
     * Sets summary_long
     *
     * @param \Swagger\Client\Model\SummaryLong $summary_long summary_long
     *
     * @return $this
     */
    public function setSummaryLong($summary_long)
    {
        $this->container['summary_long'] = $summary_long;

        return $this;
    }

    /**
     * Gets sunrise
     *
     * @return \Swagger\Client\Model\Sunrise
     */
    public function getSunrise()
    {
        return $this->container['sunrise'];
    }

    /**
     * Sets sunrise
     *
     * @param \Swagger\Client\Model\Sunrise $sunrise sunrise
     *
     * @return $this
     */
    public function setSunrise($sunrise)
    {
        $this->container['sunrise'] = $sunrise;

        return $this;
    }

    /**
     * Gets sunset
     *
     * @return \Swagger\Client\Model\Sunset
     */
    public function getSunset()
    {
        return $this->container['sunset'];
    }

    /**
     * Sets sunset
     *
     * @param \Swagger\Client\Model\Sunset $sunset sunset
     *
     * @return $this
     */
    public function setSunset($sunset)
    {
        $this->container['sunset'] = $sunset;

        return $this;
    }

    /**
     * Gets temp_max
     *
     * @return \Swagger\Client\Model\TempMax
     */
    public function getTempMax()
    {
        return $this->container['temp_max'];
    }

    /**
     * Sets temp_max
     *
     * @param \Swagger\Client\Model\TempMax $temp_max temp_max
     *
     * @return $this
     */
    public function setTempMax($temp_max)
    {
        $this->container['temp_max'] = $temp_max;

        return $this;
    }

    /**
     * Gets temp_min
     *
     * @return \Swagger\Client\Model\TempMin
     */
    public function getTempMin()
    {
        return $this->container['temp_min'];
    }

    /**
     * Sets temp_min
     *
     * @param \Swagger\Client\Model\TempMin $temp_min temp_min
     *
     * @return $this
     */
    public function setTempMin($temp_min)
    {
        $this->container['temp_min'] = $temp_min;

        return $this;
    }

    /**
     * Gets wind_dir_avg
     *
     * @return \Swagger\Client\Model\WindDirAvg
     */
    public function getWindDirAvg()
    {
        return $this->container['wind_dir_avg'];
    }

    /**
     * Sets wind_dir_avg
     *
     * @param \Swagger\Client\Model\WindDirAvg $wind_dir_avg wind_dir_avg
     *
     * @return $this
     */
    public function setWindDirAvg($wind_dir_avg)
    {
        $this->container['wind_dir_avg'] = $wind_dir_avg;

        return $this;
    }

    /**
     * Gets wind_spd_min
     *
     * @return \Swagger\Client\Model\WindSpdMin
     */
    public function getWindSpdMin()
    {
        return $this->container['wind_spd_min'];
    }

    /**
     * Sets wind_spd_min
     *
     * @param \Swagger\Client\Model\WindSpdMin $wind_spd_min wind_spd_min
     *
     * @return $this
     */
    public function setWindSpdMin($wind_spd_min)
    {
        $this->container['wind_spd_min'] = $wind_spd_min;

        return $this;
    }

    /**
     * Gets wind_spd_max
     *
     * @return \Swagger\Client\Model\WindSpdMax
     */
    public function getWindSpdMax()
    {
        return $this->container['wind_spd_max'];
    }

    /**
     * Sets wind_spd_max
     *
     * @param \Swagger\Client\Model\WindSpdMax $wind_spd_max wind_spd_max
     *
     * @return $this
     */
    public function setWindSpdMax($wind_spd_max)
    {
        $this->container['wind_spd_max'] = $wind_spd_max;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
