<?php
/**
 * ForecastHourObj
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * App Weather - A Weather Source API
 *
 * App/Webpage optimized weather data for latitude/longitude points, ZIP/Postal Codes, and OnPoint™ points. The Weather Source App Weather API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate use. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  This API returns current conditions (Nowcast) and a 7-day of daily and hourly forecast. The nowcast and forecasts include limited astronomical data.  The weather icon classes returned by this API correspond to classes used by the open source licensed [Weather Icons](https://developer.weathersourceapis.com/apis/appwx-weather-icons/) font set.      **IMPORTANT:** To authenticate to the Weather Source App Weather API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.23
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * ForecastHourObj Class Doc Comment
 *
 * @category Class
 * @description An hourly weather forecast object.
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ForecastHourObj implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'forecastHourObj';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'timestamp' => '\Swagger\Client\Model\Timestamp',
'cld_cvr' => '\Swagger\Client\Model\CldCvr',
'feels_like' => '\Swagger\Client\Model\FeelsLike',
'icon' => '\Swagger\Client\Model\Icon',
'precip' => '\Swagger\Client\Model\Precip',
'precip_prob' => '\Swagger\Client\Model\PrecipProb',
'rel_hum' => '\Swagger\Client\Model\RelHum',
'snowfall' => '\Swagger\Client\Model\Snowfall',
'snowfall_prob' => '\Swagger\Client\Model\SnowfallProb',
'summary' => '\Swagger\Client\Model\Summary',
'temp' => '\Swagger\Client\Model\Temp',
'wind_dir' => '\Swagger\Client\Model\WindDir',
'wind_spd' => '\Swagger\Client\Model\WindSpd'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'timestamp' => null,
'cld_cvr' => null,
'feels_like' => null,
'icon' => null,
'precip' => null,
'precip_prob' => null,
'rel_hum' => null,
'snowfall' => null,
'snowfall_prob' => null,
'summary' => null,
'temp' => null,
'wind_dir' => null,
'wind_spd' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'timestamp' => 'timestamp',
'cld_cvr' => 'cldCvr',
'feels_like' => 'feelsLike',
'icon' => 'icon',
'precip' => 'precip',
'precip_prob' => 'precipProb',
'rel_hum' => 'relHum',
'snowfall' => 'snowfall',
'snowfall_prob' => 'snowfallProb',
'summary' => 'summary',
'temp' => 'temp',
'wind_dir' => 'windDir',
'wind_spd' => 'windSpd'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'timestamp' => 'setTimestamp',
'cld_cvr' => 'setCldCvr',
'feels_like' => 'setFeelsLike',
'icon' => 'setIcon',
'precip' => 'setPrecip',
'precip_prob' => 'setPrecipProb',
'rel_hum' => 'setRelHum',
'snowfall' => 'setSnowfall',
'snowfall_prob' => 'setSnowfallProb',
'summary' => 'setSummary',
'temp' => 'setTemp',
'wind_dir' => 'setWindDir',
'wind_spd' => 'setWindSpd'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'timestamp' => 'getTimestamp',
'cld_cvr' => 'getCldCvr',
'feels_like' => 'getFeelsLike',
'icon' => 'getIcon',
'precip' => 'getPrecip',
'precip_prob' => 'getPrecipProb',
'rel_hum' => 'getRelHum',
'snowfall' => 'getSnowfall',
'snowfall_prob' => 'getSnowfallProb',
'summary' => 'getSummary',
'temp' => 'getTemp',
'wind_dir' => 'getWindDir',
'wind_spd' => 'getWindSpd'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['timestamp'] = isset($data['timestamp']) ? $data['timestamp'] : null;
        $this->container['cld_cvr'] = isset($data['cld_cvr']) ? $data['cld_cvr'] : null;
        $this->container['feels_like'] = isset($data['feels_like']) ? $data['feels_like'] : null;
        $this->container['icon'] = isset($data['icon']) ? $data['icon'] : null;
        $this->container['precip'] = isset($data['precip']) ? $data['precip'] : null;
        $this->container['precip_prob'] = isset($data['precip_prob']) ? $data['precip_prob'] : null;
        $this->container['rel_hum'] = isset($data['rel_hum']) ? $data['rel_hum'] : null;
        $this->container['snowfall'] = isset($data['snowfall']) ? $data['snowfall'] : null;
        $this->container['snowfall_prob'] = isset($data['snowfall_prob']) ? $data['snowfall_prob'] : null;
        $this->container['summary'] = isset($data['summary']) ? $data['summary'] : null;
        $this->container['temp'] = isset($data['temp']) ? $data['temp'] : null;
        $this->container['wind_dir'] = isset($data['wind_dir']) ? $data['wind_dir'] : null;
        $this->container['wind_spd'] = isset($data['wind_spd']) ? $data['wind_spd'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['timestamp'] === null) {
            $invalidProperties[] = "'timestamp' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets timestamp
     *
     * @return \Swagger\Client\Model\Timestamp
     */
    public function getTimestamp()
    {
        return $this->container['timestamp'];
    }

    /**
     * Sets timestamp
     *
     * @param \Swagger\Client\Model\Timestamp $timestamp timestamp
     *
     * @return $this
     */
    public function setTimestamp($timestamp)
    {
        $this->container['timestamp'] = $timestamp;

        return $this;
    }

    /**
     * Gets cld_cvr
     *
     * @return \Swagger\Client\Model\CldCvr
     */
    public function getCldCvr()
    {
        return $this->container['cld_cvr'];
    }

    /**
     * Sets cld_cvr
     *
     * @param \Swagger\Client\Model\CldCvr $cld_cvr cld_cvr
     *
     * @return $this
     */
    public function setCldCvr($cld_cvr)
    {
        $this->container['cld_cvr'] = $cld_cvr;

        return $this;
    }

    /**
     * Gets feels_like
     *
     * @return \Swagger\Client\Model\FeelsLike
     */
    public function getFeelsLike()
    {
        return $this->container['feels_like'];
    }

    /**
     * Sets feels_like
     *
     * @param \Swagger\Client\Model\FeelsLike $feels_like feels_like
     *
     * @return $this
     */
    public function setFeelsLike($feels_like)
    {
        $this->container['feels_like'] = $feels_like;

        return $this;
    }

    /**
     * Gets icon
     *
     * @return \Swagger\Client\Model\Icon
     */
    public function getIcon()
    {
        return $this->container['icon'];
    }

    /**
     * Sets icon
     *
     * @param \Swagger\Client\Model\Icon $icon icon
     *
     * @return $this
     */
    public function setIcon($icon)
    {
        $this->container['icon'] = $icon;

        return $this;
    }

    /**
     * Gets precip
     *
     * @return \Swagger\Client\Model\Precip
     */
    public function getPrecip()
    {
        return $this->container['precip'];
    }

    /**
     * Sets precip
     *
     * @param \Swagger\Client\Model\Precip $precip precip
     *
     * @return $this
     */
    public function setPrecip($precip)
    {
        $this->container['precip'] = $precip;

        return $this;
    }

    /**
     * Gets precip_prob
     *
     * @return \Swagger\Client\Model\PrecipProb
     */
    public function getPrecipProb()
    {
        return $this->container['precip_prob'];
    }

    /**
     * Sets precip_prob
     *
     * @param \Swagger\Client\Model\PrecipProb $precip_prob precip_prob
     *
     * @return $this
     */
    public function setPrecipProb($precip_prob)
    {
        $this->container['precip_prob'] = $precip_prob;

        return $this;
    }

    /**
     * Gets rel_hum
     *
     * @return \Swagger\Client\Model\RelHum
     */
    public function getRelHum()
    {
        return $this->container['rel_hum'];
    }

    /**
     * Sets rel_hum
     *
     * @param \Swagger\Client\Model\RelHum $rel_hum rel_hum
     *
     * @return $this
     */
    public function setRelHum($rel_hum)
    {
        $this->container['rel_hum'] = $rel_hum;

        return $this;
    }

    /**
     * Gets snowfall
     *
     * @return \Swagger\Client\Model\Snowfall
     */
    public function getSnowfall()
    {
        return $this->container['snowfall'];
    }

    /**
     * Sets snowfall
     *
     * @param \Swagger\Client\Model\Snowfall $snowfall snowfall
     *
     * @return $this
     */
    public function setSnowfall($snowfall)
    {
        $this->container['snowfall'] = $snowfall;

        return $this;
    }

    /**
     * Gets snowfall_prob
     *
     * @return \Swagger\Client\Model\SnowfallProb
     */
    public function getSnowfallProb()
    {
        return $this->container['snowfall_prob'];
    }

    /**
     * Sets snowfall_prob
     *
     * @param \Swagger\Client\Model\SnowfallProb $snowfall_prob snowfall_prob
     *
     * @return $this
     */
    public function setSnowfallProb($snowfall_prob)
    {
        $this->container['snowfall_prob'] = $snowfall_prob;

        return $this;
    }

    /**
     * Gets summary
     *
     * @return \Swagger\Client\Model\Summary
     */
    public function getSummary()
    {
        return $this->container['summary'];
    }

    /**
     * Sets summary
     *
     * @param \Swagger\Client\Model\Summary $summary summary
     *
     * @return $this
     */
    public function setSummary($summary)
    {
        $this->container['summary'] = $summary;

        return $this;
    }

    /**
     * Gets temp
     *
     * @return \Swagger\Client\Model\Temp
     */
    public function getTemp()
    {
        return $this->container['temp'];
    }

    /**
     * Sets temp
     *
     * @param \Swagger\Client\Model\Temp $temp temp
     *
     * @return $this
     */
    public function setTemp($temp)
    {
        $this->container['temp'] = $temp;

        return $this;
    }

    /**
     * Gets wind_dir
     *
     * @return \Swagger\Client\Model\WindDir
     */
    public function getWindDir()
    {
        return $this->container['wind_dir'];
    }

    /**
     * Sets wind_dir
     *
     * @param \Swagger\Client\Model\WindDir $wind_dir wind_dir
     *
     * @return $this
     */
    public function setWindDir($wind_dir)
    {
        $this->container['wind_dir'] = $wind_dir;

        return $this;
    }

    /**
     * Gets wind_spd
     *
     * @return \Swagger\Client\Model\WindSpd
     */
    public function getWindSpd()
    {
        return $this->container['wind_spd'];
    }

    /**
     * Sets wind_spd
     *
     * @param \Swagger\Client\Model\WindSpd $wind_spd wind_spd
     *
     * @return $this
     */
    public function setWindSpd($wind_spd)
    {
        $this->container['wind_spd'] = $wind_spd;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
