<?php
/**
 * NowcastObj
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * App Weather - A Weather Source API
 *
 * App/Webpage optimized weather data for latitude/longitude points, ZIP/Postal Codes, and OnPoint™ points. The Weather Source App Weather API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate use. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  This API returns current conditions (Nowcast) and a 7-day of daily and hourly forecast. The nowcast and forecasts include limited astronomical data.  The weather icon classes returned by this API correspond to classes used by the open source licensed [Weather Icons](https://developer.weathersourceapis.com/apis/appwx-weather-icons/) font set.      **IMPORTANT:** To authenticate to the Weather Source App Weather API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.23
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * NowcastObj Class Doc Comment
 *
 * @category Class
 * @description A nowcast object.
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class NowcastObj implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'nowcastObj';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'timestamp' => '\Swagger\Client\Model\Timestamp',
'civil_rise' => '\Swagger\Client\Model\CivilRise',
'civil_set' => '\Swagger\Client\Model\CivilSet',
'cld_cvr' => '\Swagger\Client\Model\CldCvr',
'feels_like' => '\Swagger\Client\Model\FeelsLike',
'icon' => '\Swagger\Client\Model\Icon',
'moon_phase' => '\Swagger\Client\Model\MoonPhase',
'precip_flag' => '\Swagger\Client\Model\PrecipFlag',
'precip_intensity' => '\Swagger\Client\Model\PrecipIntensity',
'rel_hum' => '\Swagger\Client\Model\RelHum',
'snowfall_flag' => '\Swagger\Client\Model\SnowfallFlag',
'snowfall_intensity' => '\Swagger\Client\Model\SnowfallIntensity',
'summary' => '\Swagger\Client\Model\Summary',
'summary_long' => '\Swagger\Client\Model\SummaryLong',
'sun_transit' => '\Swagger\Client\Model\SunTransit',
'sunrise' => '\Swagger\Client\Model\Sunrise',
'sunset' => '\Swagger\Client\Model\Sunset',
'temp' => '\Swagger\Client\Model\Temp',
'temp_max' => '\Swagger\Client\Model\TempMax',
'temp_min' => '\Swagger\Client\Model\TempMin',
'wind_dir' => '\Swagger\Client\Model\WindDir',
'wind_spd' => '\Swagger\Client\Model\WindSpd'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'timestamp' => null,
'civil_rise' => null,
'civil_set' => null,
'cld_cvr' => null,
'feels_like' => null,
'icon' => null,
'moon_phase' => null,
'precip_flag' => null,
'precip_intensity' => null,
'rel_hum' => null,
'snowfall_flag' => null,
'snowfall_intensity' => null,
'summary' => null,
'summary_long' => null,
'sun_transit' => null,
'sunrise' => null,
'sunset' => null,
'temp' => null,
'temp_max' => null,
'temp_min' => null,
'wind_dir' => null,
'wind_spd' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'timestamp' => 'timestamp',
'civil_rise' => 'civilRise',
'civil_set' => 'civilSet',
'cld_cvr' => 'cldCvr',
'feels_like' => 'feelsLike',
'icon' => 'icon',
'moon_phase' => 'moonPhase',
'precip_flag' => 'precipFlag',
'precip_intensity' => 'precipIntensity',
'rel_hum' => 'relHum',
'snowfall_flag' => 'snowfallFlag',
'snowfall_intensity' => 'snowfallIntensity',
'summary' => 'summary',
'summary_long' => 'summaryLong',
'sun_transit' => 'sunTransit',
'sunrise' => 'sunrise',
'sunset' => 'sunset',
'temp' => 'temp',
'temp_max' => 'tempMax',
'temp_min' => 'tempMin',
'wind_dir' => 'windDir',
'wind_spd' => 'windSpd'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'timestamp' => 'setTimestamp',
'civil_rise' => 'setCivilRise',
'civil_set' => 'setCivilSet',
'cld_cvr' => 'setCldCvr',
'feels_like' => 'setFeelsLike',
'icon' => 'setIcon',
'moon_phase' => 'setMoonPhase',
'precip_flag' => 'setPrecipFlag',
'precip_intensity' => 'setPrecipIntensity',
'rel_hum' => 'setRelHum',
'snowfall_flag' => 'setSnowfallFlag',
'snowfall_intensity' => 'setSnowfallIntensity',
'summary' => 'setSummary',
'summary_long' => 'setSummaryLong',
'sun_transit' => 'setSunTransit',
'sunrise' => 'setSunrise',
'sunset' => 'setSunset',
'temp' => 'setTemp',
'temp_max' => 'setTempMax',
'temp_min' => 'setTempMin',
'wind_dir' => 'setWindDir',
'wind_spd' => 'setWindSpd'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'timestamp' => 'getTimestamp',
'civil_rise' => 'getCivilRise',
'civil_set' => 'getCivilSet',
'cld_cvr' => 'getCldCvr',
'feels_like' => 'getFeelsLike',
'icon' => 'getIcon',
'moon_phase' => 'getMoonPhase',
'precip_flag' => 'getPrecipFlag',
'precip_intensity' => 'getPrecipIntensity',
'rel_hum' => 'getRelHum',
'snowfall_flag' => 'getSnowfallFlag',
'snowfall_intensity' => 'getSnowfallIntensity',
'summary' => 'getSummary',
'summary_long' => 'getSummaryLong',
'sun_transit' => 'getSunTransit',
'sunrise' => 'getSunrise',
'sunset' => 'getSunset',
'temp' => 'getTemp',
'temp_max' => 'getTempMax',
'temp_min' => 'getTempMin',
'wind_dir' => 'getWindDir',
'wind_spd' => 'getWindSpd'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['timestamp'] = isset($data['timestamp']) ? $data['timestamp'] : null;
        $this->container['civil_rise'] = isset($data['civil_rise']) ? $data['civil_rise'] : null;
        $this->container['civil_set'] = isset($data['civil_set']) ? $data['civil_set'] : null;
        $this->container['cld_cvr'] = isset($data['cld_cvr']) ? $data['cld_cvr'] : null;
        $this->container['feels_like'] = isset($data['feels_like']) ? $data['feels_like'] : null;
        $this->container['icon'] = isset($data['icon']) ? $data['icon'] : null;
        $this->container['moon_phase'] = isset($data['moon_phase']) ? $data['moon_phase'] : null;
        $this->container['precip_flag'] = isset($data['precip_flag']) ? $data['precip_flag'] : null;
        $this->container['precip_intensity'] = isset($data['precip_intensity']) ? $data['precip_intensity'] : null;
        $this->container['rel_hum'] = isset($data['rel_hum']) ? $data['rel_hum'] : null;
        $this->container['snowfall_flag'] = isset($data['snowfall_flag']) ? $data['snowfall_flag'] : null;
        $this->container['snowfall_intensity'] = isset($data['snowfall_intensity']) ? $data['snowfall_intensity'] : null;
        $this->container['summary'] = isset($data['summary']) ? $data['summary'] : null;
        $this->container['summary_long'] = isset($data['summary_long']) ? $data['summary_long'] : null;
        $this->container['sun_transit'] = isset($data['sun_transit']) ? $data['sun_transit'] : null;
        $this->container['sunrise'] = isset($data['sunrise']) ? $data['sunrise'] : null;
        $this->container['sunset'] = isset($data['sunset']) ? $data['sunset'] : null;
        $this->container['temp'] = isset($data['temp']) ? $data['temp'] : null;
        $this->container['temp_max'] = isset($data['temp_max']) ? $data['temp_max'] : null;
        $this->container['temp_min'] = isset($data['temp_min']) ? $data['temp_min'] : null;
        $this->container['wind_dir'] = isset($data['wind_dir']) ? $data['wind_dir'] : null;
        $this->container['wind_spd'] = isset($data['wind_spd']) ? $data['wind_spd'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['timestamp'] === null) {
            $invalidProperties[] = "'timestamp' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets timestamp
     *
     * @return \Swagger\Client\Model\Timestamp
     */
    public function getTimestamp()
    {
        return $this->container['timestamp'];
    }

    /**
     * Sets timestamp
     *
     * @param \Swagger\Client\Model\Timestamp $timestamp timestamp
     *
     * @return $this
     */
    public function setTimestamp($timestamp)
    {
        $this->container['timestamp'] = $timestamp;

        return $this;
    }

    /**
     * Gets civil_rise
     *
     * @return \Swagger\Client\Model\CivilRise
     */
    public function getCivilRise()
    {
        return $this->container['civil_rise'];
    }

    /**
     * Sets civil_rise
     *
     * @param \Swagger\Client\Model\CivilRise $civil_rise civil_rise
     *
     * @return $this
     */
    public function setCivilRise($civil_rise)
    {
        $this->container['civil_rise'] = $civil_rise;

        return $this;
    }

    /**
     * Gets civil_set
     *
     * @return \Swagger\Client\Model\CivilSet
     */
    public function getCivilSet()
    {
        return $this->container['civil_set'];
    }

    /**
     * Sets civil_set
     *
     * @param \Swagger\Client\Model\CivilSet $civil_set civil_set
     *
     * @return $this
     */
    public function setCivilSet($civil_set)
    {
        $this->container['civil_set'] = $civil_set;

        return $this;
    }

    /**
     * Gets cld_cvr
     *
     * @return \Swagger\Client\Model\CldCvr
     */
    public function getCldCvr()
    {
        return $this->container['cld_cvr'];
    }

    /**
     * Sets cld_cvr
     *
     * @param \Swagger\Client\Model\CldCvr $cld_cvr cld_cvr
     *
     * @return $this
     */
    public function setCldCvr($cld_cvr)
    {
        $this->container['cld_cvr'] = $cld_cvr;

        return $this;
    }

    /**
     * Gets feels_like
     *
     * @return \Swagger\Client\Model\FeelsLike
     */
    public function getFeelsLike()
    {
        return $this->container['feels_like'];
    }

    /**
     * Sets feels_like
     *
     * @param \Swagger\Client\Model\FeelsLike $feels_like feels_like
     *
     * @return $this
     */
    public function setFeelsLike($feels_like)
    {
        $this->container['feels_like'] = $feels_like;

        return $this;
    }

    /**
     * Gets icon
     *
     * @return \Swagger\Client\Model\Icon
     */
    public function getIcon()
    {
        return $this->container['icon'];
    }

    /**
     * Sets icon
     *
     * @param \Swagger\Client\Model\Icon $icon icon
     *
     * @return $this
     */
    public function setIcon($icon)
    {
        $this->container['icon'] = $icon;

        return $this;
    }

    /**
     * Gets moon_phase
     *
     * @return \Swagger\Client\Model\MoonPhase
     */
    public function getMoonPhase()
    {
        return $this->container['moon_phase'];
    }

    /**
     * Sets moon_phase
     *
     * @param \Swagger\Client\Model\MoonPhase $moon_phase moon_phase
     *
     * @return $this
     */
    public function setMoonPhase($moon_phase)
    {
        $this->container['moon_phase'] = $moon_phase;

        return $this;
    }

    /**
     * Gets precip_flag
     *
     * @return \Swagger\Client\Model\PrecipFlag
     */
    public function getPrecipFlag()
    {
        return $this->container['precip_flag'];
    }

    /**
     * Sets precip_flag
     *
     * @param \Swagger\Client\Model\PrecipFlag $precip_flag precip_flag
     *
     * @return $this
     */
    public function setPrecipFlag($precip_flag)
    {
        $this->container['precip_flag'] = $precip_flag;

        return $this;
    }

    /**
     * Gets precip_intensity
     *
     * @return \Swagger\Client\Model\PrecipIntensity
     */
    public function getPrecipIntensity()
    {
        return $this->container['precip_intensity'];
    }

    /**
     * Sets precip_intensity
     *
     * @param \Swagger\Client\Model\PrecipIntensity $precip_intensity precip_intensity
     *
     * @return $this
     */
    public function setPrecipIntensity($precip_intensity)
    {
        $this->container['precip_intensity'] = $precip_intensity;

        return $this;
    }

    /**
     * Gets rel_hum
     *
     * @return \Swagger\Client\Model\RelHum
     */
    public function getRelHum()
    {
        return $this->container['rel_hum'];
    }

    /**
     * Sets rel_hum
     *
     * @param \Swagger\Client\Model\RelHum $rel_hum rel_hum
     *
     * @return $this
     */
    public function setRelHum($rel_hum)
    {
        $this->container['rel_hum'] = $rel_hum;

        return $this;
    }

    /**
     * Gets snowfall_flag
     *
     * @return \Swagger\Client\Model\SnowfallFlag
     */
    public function getSnowfallFlag()
    {
        return $this->container['snowfall_flag'];
    }

    /**
     * Sets snowfall_flag
     *
     * @param \Swagger\Client\Model\SnowfallFlag $snowfall_flag snowfall_flag
     *
     * @return $this
     */
    public function setSnowfallFlag($snowfall_flag)
    {
        $this->container['snowfall_flag'] = $snowfall_flag;

        return $this;
    }

    /**
     * Gets snowfall_intensity
     *
     * @return \Swagger\Client\Model\SnowfallIntensity
     */
    public function getSnowfallIntensity()
    {
        return $this->container['snowfall_intensity'];
    }

    /**
     * Sets snowfall_intensity
     *
     * @param \Swagger\Client\Model\SnowfallIntensity $snowfall_intensity snowfall_intensity
     *
     * @return $this
     */
    public function setSnowfallIntensity($snowfall_intensity)
    {
        $this->container['snowfall_intensity'] = $snowfall_intensity;

        return $this;
    }

    /**
     * Gets summary
     *
     * @return \Swagger\Client\Model\Summary
     */
    public function getSummary()
    {
        return $this->container['summary'];
    }

    /**
     * Sets summary
     *
     * @param \Swagger\Client\Model\Summary $summary summary
     *
     * @return $this
     */
    public function setSummary($summary)
    {
        $this->container['summary'] = $summary;

        return $this;
    }

    /**
     * Gets summary_long
     *
     * @return \Swagger\Client\Model\SummaryLong
     */
    public function getSummaryLong()
    {
        return $this->container['summary_long'];
    }

    /**
     * Sets summary_long
     *
     * @param \Swagger\Client\Model\SummaryLong $summary_long summary_long
     *
     * @return $this
     */
    public function setSummaryLong($summary_long)
    {
        $this->container['summary_long'] = $summary_long;

        return $this;
    }

    /**
     * Gets sun_transit
     *
     * @return \Swagger\Client\Model\SunTransit
     */
    public function getSunTransit()
    {
        return $this->container['sun_transit'];
    }

    /**
     * Sets sun_transit
     *
     * @param \Swagger\Client\Model\SunTransit $sun_transit sun_transit
     *
     * @return $this
     */
    public function setSunTransit($sun_transit)
    {
        $this->container['sun_transit'] = $sun_transit;

        return $this;
    }

    /**
     * Gets sunrise
     *
     * @return \Swagger\Client\Model\Sunrise
     */
    public function getSunrise()
    {
        return $this->container['sunrise'];
    }

    /**
     * Sets sunrise
     *
     * @param \Swagger\Client\Model\Sunrise $sunrise sunrise
     *
     * @return $this
     */
    public function setSunrise($sunrise)
    {
        $this->container['sunrise'] = $sunrise;

        return $this;
    }

    /**
     * Gets sunset
     *
     * @return \Swagger\Client\Model\Sunset
     */
    public function getSunset()
    {
        return $this->container['sunset'];
    }

    /**
     * Sets sunset
     *
     * @param \Swagger\Client\Model\Sunset $sunset sunset
     *
     * @return $this
     */
    public function setSunset($sunset)
    {
        $this->container['sunset'] = $sunset;

        return $this;
    }

    /**
     * Gets temp
     *
     * @return \Swagger\Client\Model\Temp
     */
    public function getTemp()
    {
        return $this->container['temp'];
    }

    /**
     * Sets temp
     *
     * @param \Swagger\Client\Model\Temp $temp temp
     *
     * @return $this
     */
    public function setTemp($temp)
    {
        $this->container['temp'] = $temp;

        return $this;
    }

    /**
     * Gets temp_max
     *
     * @return \Swagger\Client\Model\TempMax
     */
    public function getTempMax()
    {
        return $this->container['temp_max'];
    }

    /**
     * Sets temp_max
     *
     * @param \Swagger\Client\Model\TempMax $temp_max temp_max
     *
     * @return $this
     */
    public function setTempMax($temp_max)
    {
        $this->container['temp_max'] = $temp_max;

        return $this;
    }

    /**
     * Gets temp_min
     *
     * @return \Swagger\Client\Model\TempMin
     */
    public function getTempMin()
    {
        return $this->container['temp_min'];
    }

    /**
     * Sets temp_min
     *
     * @param \Swagger\Client\Model\TempMin $temp_min temp_min
     *
     * @return $this
     */
    public function setTempMin($temp_min)
    {
        $this->container['temp_min'] = $temp_min;

        return $this;
    }

    /**
     * Gets wind_dir
     *
     * @return \Swagger\Client\Model\WindDir
     */
    public function getWindDir()
    {
        return $this->container['wind_dir'];
    }

    /**
     * Sets wind_dir
     *
     * @param \Swagger\Client\Model\WindDir $wind_dir wind_dir
     *
     * @return $this
     */
    public function setWindDir($wind_dir)
    {
        $this->container['wind_dir'] = $wind_dir;

        return $this;
    }

    /**
     * Gets wind_spd
     *
     * @return \Swagger\Client\Model\WindSpd
     */
    public function getWindSpd()
    {
        return $this->container['wind_spd'];
    }

    /**
     * Sets wind_spd
     *
     * @param \Swagger\Client\Model\WindSpd $wind_spd wind_spd
     *
     * @return $this
     */
    public function setWindSpd($wind_spd)
    {
        $this->container['wind_spd'] = $wind_spd;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
