<?php
/**
 * OnpointObj
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * App Weather - A Weather Source API
 *
 * App/Webpage optimized weather data for latitude/longitude points, ZIP/Postal Codes, and OnPoint™ points. The Weather Source App Weather API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate use. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  This API returns current conditions (Nowcast) and a 7-day of daily and hourly forecast. The nowcast and forecasts include limited astronomical data.  The weather icon classes returned by this API correspond to classes used by the open source licensed [Weather Icons](https://developer.weathersourceapis.com/apis/appwx-weather-icons/) font set.      **IMPORTANT:** To authenticate to the Weather Source App Weather API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.23
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * OnpointObj Class Doc Comment
 *
 * @category Class
 * @description An OnPoint™ point location metadata object
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class OnpointObj implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'onpointObj';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'onpoint_id' => '\Swagger\Client\Model\OnpointId',
'latitude' => '\Swagger\Client\Model\Latitude',
'longitude' => '\Swagger\Client\Model\Longitude',
'timezone' => '\Swagger\Client\Model\Timezone',
'country_code' => '\Swagger\Client\Model\CountryCode',
'country_name' => '\Swagger\Client\Model\CountryName',
'subdiv_code' => '\Swagger\Client\Model\SubdivCode',
'subdiv_name' => '\Swagger\Client\Model\SubdivName',
'grid' => '\Swagger\Client\Model\Grid',
'elevation' => '\Swagger\Client\Model\Elevation'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'onpoint_id' => null,
'latitude' => null,
'longitude' => null,
'timezone' => null,
'country_code' => null,
'country_name' => null,
'subdiv_code' => null,
'subdiv_name' => null,
'grid' => null,
'elevation' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'onpoint_id' => 'onpointId',
'latitude' => 'latitude',
'longitude' => 'longitude',
'timezone' => 'timezone',
'country_code' => 'countryCode',
'country_name' => 'countryName',
'subdiv_code' => 'subdivCode',
'subdiv_name' => 'subdivName',
'grid' => 'grid',
'elevation' => 'elevation'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'onpoint_id' => 'setOnpointId',
'latitude' => 'setLatitude',
'longitude' => 'setLongitude',
'timezone' => 'setTimezone',
'country_code' => 'setCountryCode',
'country_name' => 'setCountryName',
'subdiv_code' => 'setSubdivCode',
'subdiv_name' => 'setSubdivName',
'grid' => 'setGrid',
'elevation' => 'setElevation'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'onpoint_id' => 'getOnpointId',
'latitude' => 'getLatitude',
'longitude' => 'getLongitude',
'timezone' => 'getTimezone',
'country_code' => 'getCountryCode',
'country_name' => 'getCountryName',
'subdiv_code' => 'getSubdivCode',
'subdiv_name' => 'getSubdivName',
'grid' => 'getGrid',
'elevation' => 'getElevation'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['onpoint_id'] = isset($data['onpoint_id']) ? $data['onpoint_id'] : null;
        $this->container['latitude'] = isset($data['latitude']) ? $data['latitude'] : null;
        $this->container['longitude'] = isset($data['longitude']) ? $data['longitude'] : null;
        $this->container['timezone'] = isset($data['timezone']) ? $data['timezone'] : null;
        $this->container['country_code'] = isset($data['country_code']) ? $data['country_code'] : null;
        $this->container['country_name'] = isset($data['country_name']) ? $data['country_name'] : null;
        $this->container['subdiv_code'] = isset($data['subdiv_code']) ? $data['subdiv_code'] : null;
        $this->container['subdiv_name'] = isset($data['subdiv_name']) ? $data['subdiv_name'] : null;
        $this->container['grid'] = isset($data['grid']) ? $data['grid'] : null;
        $this->container['elevation'] = isset($data['elevation']) ? $data['elevation'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['onpoint_id'] === null) {
            $invalidProperties[] = "'onpoint_id' can't be null";
        }
        if ($this->container['latitude'] === null) {
            $invalidProperties[] = "'latitude' can't be null";
        }
        if ($this->container['longitude'] === null) {
            $invalidProperties[] = "'longitude' can't be null";
        }
        if ($this->container['timezone'] === null) {
            $invalidProperties[] = "'timezone' can't be null";
        }
        if ($this->container['grid'] === null) {
            $invalidProperties[] = "'grid' can't be null";
        }
        if ($this->container['elevation'] === null) {
            $invalidProperties[] = "'elevation' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets onpoint_id
     *
     * @return \Swagger\Client\Model\OnpointId
     */
    public function getOnpointId()
    {
        return $this->container['onpoint_id'];
    }

    /**
     * Sets onpoint_id
     *
     * @param \Swagger\Client\Model\OnpointId $onpoint_id onpoint_id
     *
     * @return $this
     */
    public function setOnpointId($onpoint_id)
    {
        $this->container['onpoint_id'] = $onpoint_id;

        return $this;
    }

    /**
     * Gets latitude
     *
     * @return \Swagger\Client\Model\Latitude
     */
    public function getLatitude()
    {
        return $this->container['latitude'];
    }

    /**
     * Sets latitude
     *
     * @param \Swagger\Client\Model\Latitude $latitude latitude
     *
     * @return $this
     */
    public function setLatitude($latitude)
    {
        $this->container['latitude'] = $latitude;

        return $this;
    }

    /**
     * Gets longitude
     *
     * @return \Swagger\Client\Model\Longitude
     */
    public function getLongitude()
    {
        return $this->container['longitude'];
    }

    /**
     * Sets longitude
     *
     * @param \Swagger\Client\Model\Longitude $longitude longitude
     *
     * @return $this
     */
    public function setLongitude($longitude)
    {
        $this->container['longitude'] = $longitude;

        return $this;
    }

    /**
     * Gets timezone
     *
     * @return \Swagger\Client\Model\Timezone
     */
    public function getTimezone()
    {
        return $this->container['timezone'];
    }

    /**
     * Sets timezone
     *
     * @param \Swagger\Client\Model\Timezone $timezone timezone
     *
     * @return $this
     */
    public function setTimezone($timezone)
    {
        $this->container['timezone'] = $timezone;

        return $this;
    }

    /**
     * Gets country_code
     *
     * @return \Swagger\Client\Model\CountryCode
     */
    public function getCountryCode()
    {
        return $this->container['country_code'];
    }

    /**
     * Sets country_code
     *
     * @param \Swagger\Client\Model\CountryCode $country_code country_code
     *
     * @return $this
     */
    public function setCountryCode($country_code)
    {
        $this->container['country_code'] = $country_code;

        return $this;
    }

    /**
     * Gets country_name
     *
     * @return \Swagger\Client\Model\CountryName
     */
    public function getCountryName()
    {
        return $this->container['country_name'];
    }

    /**
     * Sets country_name
     *
     * @param \Swagger\Client\Model\CountryName $country_name country_name
     *
     * @return $this
     */
    public function setCountryName($country_name)
    {
        $this->container['country_name'] = $country_name;

        return $this;
    }

    /**
     * Gets subdiv_code
     *
     * @return \Swagger\Client\Model\SubdivCode
     */
    public function getSubdivCode()
    {
        return $this->container['subdiv_code'];
    }

    /**
     * Sets subdiv_code
     *
     * @param \Swagger\Client\Model\SubdivCode $subdiv_code subdiv_code
     *
     * @return $this
     */
    public function setSubdivCode($subdiv_code)
    {
        $this->container['subdiv_code'] = $subdiv_code;

        return $this;
    }

    /**
     * Gets subdiv_name
     *
     * @return \Swagger\Client\Model\SubdivName
     */
    public function getSubdivName()
    {
        return $this->container['subdiv_name'];
    }

    /**
     * Sets subdiv_name
     *
     * @param \Swagger\Client\Model\SubdivName $subdiv_name subdiv_name
     *
     * @return $this
     */
    public function setSubdivName($subdiv_name)
    {
        $this->container['subdiv_name'] = $subdiv_name;

        return $this;
    }

    /**
     * Gets grid
     *
     * @return \Swagger\Client\Model\Grid
     */
    public function getGrid()
    {
        return $this->container['grid'];
    }

    /**
     * Sets grid
     *
     * @param \Swagger\Client\Model\Grid $grid grid
     *
     * @return $this
     */
    public function setGrid($grid)
    {
        $this->container['grid'] = $grid;

        return $this;
    }

    /**
     * Gets elevation
     *
     * @return \Swagger\Client\Model\Elevation
     */
    public function getElevation()
    {
        return $this->container['elevation'];
    }

    /**
     * Sets elevation
     *
     * @param \Swagger\Client\Model\Elevation $elevation elevation
     *
     * @return $this
     */
    public function setElevation($elevation)
    {
        $this->container['elevation'] = $elevation;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
